;        _________  _____
;        \___  ___\ \  _ \         TRANSFILE PC<=>CPC TRANSFER UTILITY
;            \ \     \ \\ \_       COPYRIGHT 1995,96 MICROTEK SOFTWARE
;             \ \     \  __ \
;              \ \     \ \ \ \     SOURCE: PCTR.ASM 80X86 ASSEMBLY MODULE
;               \ \     \ \ \ \    REQUIREMENTS: 16MHZ OR FASTER CPU

                ORG 0100H
                JMP BEGIN
NOTFOUND$       DB "File not found",13,10,"$"
FERROR$         DB "An internal file error occurred",13,10,"$"
ENDFILE$        DB "EOF reached",13,10,"$"
ENDCONNECT$     DB "Finished connection",13,10,"$"
NOCONNECT$      DB "Connection broken",13,10,"$"
TRANS$          DB "CURRENTLY TRANSMITTING",13,10,"$"
SUCCESS$        DB "TRANSFER SUCCESSFUL",13,10,"$"
DIRNOTFOUND$    DB "Directory not found",13,10,"$"
DIRERROR$       DB "Directory error",13,10,"$"
FILENAME$       DB "Filename:      $"    
FILETYPE$       DB "File Type:     $"
FT0$            DB "Locomotive BASIC",13,10,"$"
FT1$            DB "Binary",13,10,"$"
FT2$            DB "Screen Image",13,10,"$"
FT3$            DB "ASCII",13,10,"$"
NOTYPE$         DB "Invalid Filetype",13,10,"$"
START$          DB "Start Address: $"
LENGTH$         DB "Length:        $"
EXEC$           DB "Exec Address:  $"
CURDIR$         DB "DIRECTORY OF \","$"
HEADINFO$       DB "FILE HEADER INFORMATION $"
SAVEFILE$       DB "Saving file: $"
WILDFILE$       DB "*.*",0
MESG$           DB "TRANFILE PC<=>CPC Transfer Utility",13,10
                DB "(C)1995,96 Microtek Software",13,10,13,10,"$"
ENDOFFILE       DW ?
FLENGTH         DW ?
FILEEND         DW ?                        

BEGIN:          CALL INTROMESSAGE               ; Display operation message
NEXT:           CALL GETNAMEINFO                ; Get filename from CPC
                CALL CHECKSAVE
                CALL CHECKCD                    
                CALL CHECKINFO
                CALL CHECKDIR
                CALL LOADHEADER                 ; Load file header from disk
                CALL LENGTHCHK
                CALL LOADDATA                   ; Load file data from disk
                MOV AL,01H                      ; Send file found OK code
                CALL TRANSBYTE
                CALL TRANSHEADER                ; Transmit file header to CPC
                CALL TRANSDATA                  ; Transmit file data to CPC
                CALL SUCCESSMESSAGE             
                JMP NEXT
ERROR:          MOV AH,9                        ; Display error message
                INT 21H
                INT 20H
LOADHEADER:     MOV DX,OFFSET FILENAME          ; DS:DX points to fname
LHINFO:         MOV AH,3DH                      ; DOSFN open
                MOV AL,00H                      ; RO access code
                INT 21H
                JC NOFILEFOUND                  ; no file found
                MOV BX,AX
                MOV AH,3FH                      ; DOSFN read file
                MOV CX,0080H                    ; 80H length header
                MOV DX,1000H                    ; At 1000H
                INT 21H     
                CMP AX,0000H                    ; tried to read from EOF?
                JE ENDOFFILEERR 
                CMP CX,AX                       ; subtract AX from CX
                JG ENDOFFILEERR                 ; jump if EOF reached before
                JB FILEERROR                    ; if carry flag set, gen err
                MOV AH,3EH                      ; DOSFN - close
                INT 21H
                RET
LENGTHCHK:      MOV SI,1000H+25                 ; LENGTH (H)
                LODSB
                MOV AH,AL                   
                MOV SI,1000H+24                 ; LENGTH (L)
                LODSB                           ; Length stored in AX now
                ADD AX,0080H                    ; Add header length 80H
                MOV FLENGTH,AX                  ; Store as filelength
                ADD AX,1000H                    ; Add on the starting location
                MOV FILEEND,AX                  ; Store as fileend
                RET
LOADDATA:       MOV DX,OFFSET FILENAME          ; DS:DX point to fname
                MOV AH,3DH                      ; DOSFN open
                MOV AL,00H                      ; RO access code
                INT 21H
                JC NOFILEFOUND                  ; no file found
                MOV BX,AX
                MOV AH,3FH                      ; DOSFN read file
                MOV CX,FLENGTH
                MOV DX,1000H
                INT 21H     
                CMP AX,0000H                    ; tried to read from EOF?
                JE ENDOFFILEERR 
                CMP CX,AX                       ; subtract AX from CX
                JG ENDOFFILEERR                 ; jump if EOF reached before
                JB FILEERROR                    ; if carry flag set, gen err
                MOV SI,FILEEND
                MOV BYTE PTR [SI],1AH           ; add end of file character
                MOV AH,3EH                      ; DOSFN - close
                INT 21H
                RET
NOFILEFOUND:    MOV AL,02H                      ; Send error code
                CALL TRANSBYTE
                MOV DX,OFFSET NOTFOUND$         ; File not found
                MOV AH,9
                INT 21H
                JMP NEXT
FILEERROR:      MOV DX,OFFSET FERROR$           ; General file error
                JMP ERROR
ENDOFFILEERR:   MOV DX,0000H                    ; Nothing read
                CALL PRINTHEX
                MOV DX,OFFSET ENDFILE$          ; End of file reached
                JMP ERROR
INTROMESSAGE:   MOV DX,OFFSET MESG$             ; Display intro message
                MOV AH,09H
                INT 21H
                RET                
SUCCESSMESSAGE: MOV DX,OFFSET SUCCESS$          ; Display message
                MOV AH,9
                INT 21H
                RET                
CHECKSAVE:      MOV SI,OFFSET FILENAME          ; See if save file
                LODSB
                CMP AL,"*"
                JZ SAVEFILE
                RET
SAVEFILE:       MOV SI,1000H                    ; Fill header bytes
FS:             MOV BYTE PTR [SI],0
                INC SI
                CMP SI,1080H
                JNZ FS
                MOV DX,OFFSET SAVEFILE$
                MOV AH,09H
                INT 21H
                MOV SI,1000H+1                  ; Point at fname loc
                CALL RECBYTE                    ; Get length (from CL)
                MOV BH,CL                       ; Store length in BH
L10:            CALL RECBYTE                    ; Get next character (from CL)
                MOV AL,CL                       ; Grab character to print
                MOV AH,0EH                      ; Write character TTY mode
                INT 10H
                MOV BYTE PTR [SI],AL            ; Store character at DX
                INC SI
                DEC BH                          ; Decrease counter
                JNZ L10                         ; Jump to get next char if NZ
                CALL BIGWAIT
                CALL RECBYTE
                MOV SI,1000H+18
                MOV BYTE PTR [SI],CL            ; Store filetype
                MOV SI,1000H+21
                CALL RECBYTE                    ; Store Data location=LLHH
                MOV BYTE PTR [SI],CL
                INC SI
                CALL RECBYTE
                MOV BYTE PTR [SI],CL
                INC SI
                MOV BYTE PTR [SI],0FFH          ; Store FF
                INC SI
                CALL RECBYTE                    ; Store length=LLHH
                MOV BYTE PTR [SI],CL
                MOV DL,CL
                INC SI
                CALL RECBYTE
                MOV BYTE PTR [SI],CL
                MOV DH,CL
                INC SI
                CALL RECBYTE                    ; Store Exec address=LLHH
                MOV BYTE PTR [SI],CL
                INC SI
                CALL RECBYTE
                MOV BYTE PTR [SI],CL
                MOV SI,1000H+64
                MOV BYTE PTR [SI],DL            ; Store file length
                INC SI
                MOV BYTE PTR [SI],DH
                PUSH DX
                MOV DX,0                        ; Reset checksum
                MOV AX,0
                MOV SI,1000H
NEXTCHK:        LODSB
                ADD DX,AX                       ; Add up header checksum
                CMP SI,1080H
                JNZ NEXTCHK
                MOV SI,1000H+67                 ; Store header checksum
                MOV BYTE PTR [SI],DL
                INC SI
                MOV BYTE PTR [SI],DH
                POP DX
                MOV FLENGTH,DX
                MOV SI,1080H
NEXTCHR:        CALL RECBYTE                    ; Receive bytes to save in CL
                MOV BYTE PTR [SI],CL
                INC SI
                DEC DX
                JNZ NEXTCHR
SAVEHEADER:     MOV DX,1001H                    ; DS:DX points to fname
                MOV AH,3CH                      ; DOSFN create
                MOV CX,00H                      ; Attributes
                INT 21H
                MOV BX,AX                       ; Pass on handle
                MOV AH,40H                      ; DOSFN write file
                MOV DX,1000H                    ; Start
                MOV CX,FLENGTH                  ; Length
                ADD CX,80H
                INT 21H
                MOV AH,3EH                      ; DOSFN close file
                INT 21H
                CALL NEWLINE
                JMP NEXT
CHECKDIR:       MOV SI,OFFSET FILENAME          ; See if filename is DIR
                LODSB
                CMP AL,"D"
                JZ NEXTD1
                CMP AL,"d"
                JZ NEXTD1
                RET
NEXTD1:         LODSB
                CMP AL,"I"
                JZ NEXTD2
                CMP AL,"i"
                JZ NEXTD2
                RET
NEXTD2:         LODSB
                CMP AL,"R"
                JZ NEXTD3
                CMP AL,"r"
                JZ NEXTD3
                RET
NEXTD3:         JMP PRINTDIR
CHECKINFO:      MOV SI,OFFSET FILENAME          ; See if filename is FH
                LODSB
                CMP AL,"F"
                JZ NEXTFO1
                CMP AL,"f"
                JZ NEXTFO1
                RET
NEXTFO1:        LODSB
                CMP AL,"H"
                JZ NEXTFO2
                CMP AL,"h"
                JZ NEXTFO2
                RET
NEXTFO2:        MOV DX,OFFSET FILENAME+3
                CALL LHINFO
                CALL FHINFO
                MOV AL,02H
                CALL TRANSBYTE
                JMP NEXT
FHINFO:         CALL NEWLINE
                MOV DX,OFFSET HEADINFO$
                MOV AH,09H
                INT 21H
                CALL NEWLINE
                CALL PRINTLINE
                CALL NEWLINE
                MOV DX,OFFSET FILENAME$
                MOV AH,09H
                INT 21H
                MOV SI,1000H+1
TH1:            LODSB
                CMP SI,1000H+13
                JZ TH2
                MOV AH,0EH
                INT 10H
                JMP TH1
TH2:            CALL NEWLINE
                MOV DX,OFFSET FILETYPE$
                MOV AH,09H
                INT 21H
                MOV SI,1000H+18
                LODSB
                CMP AL,0
                JZ FT0
                CMP AL,1
                JZ FT0
                CMP AL,2
                JZ FT1
                CMP AL,4
                JZ FT2
                CMP AL,8
                JZ FT3
                MOV DX,OFFSET NOTYPE$
                JMP DISTYPE
FT0:            MOV DX,OFFSET FT0$
                JMP DISTYPE
FT1:            MOV DX,OFFSET FT1$
                JMP DISTYPE
FT2:            MOV DX,OFFSET FT2$
                JMP DISTYPE
FT3:            MOV DX,OFFSET FT3$
                JMP DISTYPE
DISTYPE:        MOV AH,09H
                INT 21H
                MOV SI,1000H+21
                MOV DX,OFFSET START$
                CALL HEADINFO
                LODSB
                MOV DX,OFFSET LENGTH$
                CALL HEADINFO
                MOV DX,OFFSET EXEC$
                CALL HEADINFO
                CALL PRINTLINE
                CALL NEWLINE
                RET
TRANSHEADER:    MOV DX,OFFSET TRANS$
                MOV AH,09H
                INT 21H
                MOV SI,1000H+21                 ; LOCATION 21,22 (LH)
                LODSB
                CALL TRANSBYTE
                LODSB
                CALL TRANSBYTE
                MOV SI,1000H+24                 ; LENGTH 24,25 (LH)
                LODSB
                CALL TRANSBYTE
                LODSB
                CALL TRANSBYTE
                MOV SI,1000H+26                 ; EXEC 26,27 (LH)
                LODSB                           
                CALL TRANSBYTE
                LODSB
                CALL TRANSBYTE
                MOV SI,1000H+18                 ; FILETYPE 18 (L)
                LODSB
                CALL TRANSBYTE
                RET
HEADINFO:       MOV AH,09H
                INT 21H
                LODSB
                MOV DL,AL
                LODSB
                MOV DH,AL
                CALL PRINTHEX
                RET
GETNAMEINFO:    MOV BL,0
                MOV DX,0378H
                MOV AL,1
                OUT DX,AL
                JMP WAITSIGNAL
TRYCONNECT:     CALL BIGWAIT
                CALL RECBYTE                    ; Get length (from CL)
                CMP CL,255
                JZ NOTCONNECTED
                CMP CL,0
                JZ NOTCONNECTED
                MOV BH,CL                       ; Store length in BH
                MOV SI,OFFSET FILENAME          ; Filename Temp store
L7:             CALL RECBYTE                    ; Get next character (from CL)
                MOV AL,CL                       ; Grab character to print
                MOV AH,0EH                      ; Write character TTY mode
                INT 10H
                MOV BYTE PTR [SI],AL            ; Store character at DX
                INC SI
                DEC BH                          ; Decrease counter
                JNZ L7                          ; Jump to get next char if NZ
                MOV BYTE PTR [SI],0             ; Turn last item into ASCIIZ
                CALL NEWLINE
                CALL NEWLINE
                RET                
NOTCONNECTED:   MOV DX,OFFSET NOCONNECT$
                MOV AH,9
                INT 21H
                JMP NEXT
WAITSIGNAL:     MOV CX,5000H
WS:             MOV DX,0379H
                IN AL,DX
                AND AL,80H
                JNZ TRYCONNECT
                DEC CX
                JNZ WS
ROLLER:         MOV DL,45
                CMP BL,0
                JZ DISCHAR
                MOV DL,47
                CMP BL,1
                JZ DISCHAR
                MOV DL,124
                CMP BL,2
                JZ DISCHAR
                MOV DL,92
                CMP BL,3
                JZ DISCHAR
                MOV BL,0
                JMP ROLLER
DISCHAR:        MOV AH,2                        ; DOSFN print char (DL=char)
                INT 21H
                MOV DL,8
                INT 21H
                INC BL
                JMP WAITSIGNAL
BIGWAIT:        PUSH BX
                MOV BX,0FFFFH
BW1:            DEC BX
                JNZ BW1
                POP BX
                RET
CHECKCD:        MOV SI,OFFSET FILENAME          ; See if filename is CD?
                LODSB
                CMP AL,"C"
                JZ NEXTCHD1
                CMP AL,"c"
                JZ NEXTCHD1
                RET
NEXTCHD1:       LODSB
                CMP AL,"D"
                JZ NEXTCHD2
                CMP AL,"d"
                JZ NEXTCHD2
                RET
NEXTCHD2:       LODSB
                MOV DX,OFFSET FILENAME+2
                CMP AL," "
                JNZ ENDCHK
                INC DX
ENDCHK:         MOV AH,3BH
                INT 21H                         ; Change directory
                JC NODIR                        ; Directory doesnt exist
PRINTDIR:       MOV AL,2
                CALL TRANSBYTE
                MOV DX,OFFSET CURDIR$
                MOV AH,9
                INT 21H                         ; Print there is directory
                MOV AH,47H
                MOV DL,00H
                MOV SI,OFFSET FILENAME          ; Get current directory
                INT 21H
CHKNCHAR:       LODSB
                CMP AL,0
                JZ DIRFILES
                MOV AH,0EH
                INT 10H                         ; Print current directory
                JMP CHKNCHAR
NODIR:          MOV DX,OFFSET DIRNOTFOUND$
                MOV AH,9
                INT 21H
                MOV AL,3
                CALL TRANSBYTE
                JMP NEXT
DIRFILES:       CALL NEWLINE
                CALL PRINTLINE
                CALL NEWLINE
                MOV DX,OFFSET WILDFILE$
                MOV CX,63
                MOV AH,4EH                      ; DOSFN Get first dir entry
                INT 21H
                JC NODIR
                MOV CL,0
                MOV BL,0
                CALL DPRINT
DLOOP:          MOV AH,4FH                      ; DOSFN Get next dir entry
                INT 21H
                JC DIRFINISH
                CALL DPRINT
                JMP DLOOP
DIRFINISH:      CALL NEWLINE
                CALL PRINTLINE
                CALL NEWLINE
                JMP NEXT
DPRINT:         MOV SI,9EH
DPN:            LODSB
                CMP SI,9EH+13
                JZ TABLINE
                CMP AL,0
                JZ DPRINTS
                CMP BL,1
                JZ DPRINTS
                MOV AH,0EH
                INT 10H
                JMP DPN
DPRINTS:        MOV BL,1
                MOV AH,0EH
                MOV AL,32
                INT 10H
                JMP DPN
PRINTLINE:      MOV AH,0AH
                MOV AL,"_"
                MOV BX,0
                MOV CX,80
                INT 10H
                CALL NEWLINE
                RET
TABLINE:        MOV AH,02H
                MOV BH,3
                MOV DL,32
TLCHR:          INT 21H
                DEC BH
                JNZ TLCHR
                INC CL
                CMP CL,5
                MOV BL,0
                JZ ENDTAB
                RET
ENDTAB:         MOV CL,0
                JMP NEWLINE
NEWLINE:        MOV AH,02H
                MOV DL,13
                INT 21H
                MOV DL,10
                INT 21H
                RET
PRINTHEX:       PUSH AX
                MOV AL,DH
                AND AL,00F0H
                ROR AL,4
                CALL PCHAR
                MOV AL,DH
                AND AL,000FH
                CALL PCHAR
                MOV AL,DL
                AND AL,00F0H
                ROR AL,4
                CALL PCHAR
                MOV AL,DL
                AND AL,000FH
                CALL PCHAR
                MOV AH,0EH
                MOV AL,48H
                INT 10H
                MOV AL,13
                INT 10H
                MOV AL,10
                INT 10H
                POP AX
                RET
PCHAR:          ADD AL,48
                CMP AL,57
                JLE CHARDIS
                ADD AL,7
CHARDIS:        MOV AH,0EH
                INT 10H
                RET
TRANSDATA:      MOV SI,1080H
NEXTCH:         MOV DX,SI
                DEC DX
                LODSB
                CMP DX,FILEEND
                JE ENDFILE
                CALL TRANSBYTE                  ; Else transmit byte of data
                JMP NEXTCH                      ; Time for next byte
ENDFILE:        RET
TRANSBYTE:      PUSHA
                MOV BH,AL                       ; Put byte in AL to transmit
                MOV CL,8                        ; Counter for bits in byte
L0:             MOV BL,0                        ; Set transmit bit to 0
                MOV AL,BH                       ; Store byte temporarily in AL
                AND AL,80H                      ; See if LHS bit is set
                JZ L1                           ; If so, jump to L1
                MOV BL,1                        ; Else set transmit bit to 1
L1:             RCL BH,1                        ; Rotate bits in BH to left
L2:             MOV DX,0379H                    ; Store LPT 379H port no
                IN AL,DX                        ; Read in byte from it
                AND AL,80H                      ; See if LHS bit is set
                JNZ L2                          ; If not then jump back to L2
                MOV DX,0378H                    ; Else store LPT 378H port no
                MOV AL,BL                       ; Get bit to send in AL
                OUT DX,AL                       ; Transmit bit to send (1/0)
L3:             MOV DX,0379H                    ; Store LPT 379H port no
                IN AL,DX                        ; Read in byte from it
                AND AL,80H                      ; See if LHS bit is set
                JZ L3                           ; If so then jump back to L3
                DEC CL                          ; Else decrement bit count and
                JNZ L0                          ; If Not Zero L0 for next bit
                POPA
                RET                             ; Else byte transmitted return
RECBYTE:        PUSH AX
                PUSH BX
                PUSH DX
                MOV BL,8                        ; Returns byte in CL
                MOV CL,0                        ; Temp store for receive byte
L4:             RCL CL,1
                CALL PW
                MOV DX,0378H                    ; Set LPT output 0378H
                MOV AL,0                        ; Byte output 0
                OUT DX,AL                       ; Send ready to recieve
                CALL PW
                MOV DX,0379H                    ; Set LPT input 0379H
                IN AL,DX                        ; Get next byte in AL
                PUSH AX
                MOV DX,0378H                    ; Set LPT output 0378H
                MOV AL,1                        ; Byte output 1
                OUT DX,AL                       ; Clear receive bit
                POP AX
                MOV CH,0                        ; Initial bit CH=0
                AND AL,80H                      ; Is MSB in AL set?
                JZ L5                           ; If not, jump
                MOV CH,1                        ; else CH=1
L5:             ADD CL,CH                       ; Add LSB (1/0) to CL
                DEC BL                          ; Decrement BL, does BL=0?
                JNZ L4                          ; If so, jump to L4
                POP DX
                POP BX
                POP AX
                RET                             ; Else finished, byte in CL
PW:             PUSH AX
                MOV AX,0900H                    ; Wait for these cycles
L6:             DEC AX
                JNZ L6
                POP AX
                RET
FILENAME        LABEL   BYTE
